VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private m_oForm As monitor.frmPlugin
Private m_sName As String
Private Const VER_PLATFORM_WIN32_NT = 2

'windows-defined type OSVERSIONINFO
Private Type OSVERSIONINFO
  OSVSize         As Long         'size, in bytes, of this data structure
  dwVerMajor      As Long         'ie NT 3.51, dwVerMajor = 3; NT 4.0, dwVerMajor = 4.
  dwVerMinor      As Long         'ie NT 3.51, dwVerMinor = 51; NT 4.0, dwVerMinor= 0.
  dwBuildNumber   As Long         'NT: build number of the OS
                                  'Win9x: build number of the OS in low-order word.
                                  '       High-order word contains major & minor ver nos.
  PlatformID      As Long         'Identifies the operating system platform.
  szCSDVersion    As String * 128 'NT: string, such as "Service Pack 3"
                                  'Win9x: 'arbitrary additional information'
End Type

Private Sub IBasePlugin_StopPlugin()
    
    Call m_oForm.Hide
    Call Unload(m_oForm)
    Set m_oForm = Nothing

End Sub
Public Function IBasePlugin_StartPlugin(Name As String) As Long

    Dim temp As String
    Dim OSV As OSVERSIONINFO
    Dim r As Long
    Dim pos As Integer
    Dim sVer As String
    Dim sBuild As String
   
    Set oServer = CreateObject("core.CServer")
    OSV.OSVSize = Len(OSV)
    If GetVersionEx(OSV) = 1 Then
      If OSV.PlatformID = VER_PLATFORM_WIN32_NT Then
        m_sName = Name
        Set m_oForm = New monitor.frmPlugin
        Call Load(m_oForm)
        
        oServer.RegisterBang Name, "!hide"
        oServer.RegisterBang Name, "!show"
        oServer.RegisterBang Name, "!toggle"
        
        m_oForm.Tag = m_sName
        m_oForm.Caption = m_sName
        m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX
        m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY
        m_oForm.Width = oServer.evalNum(oServer.GetKey(Name, "width")) * Screen.TwipsPerPixelX
        m_oForm.Height = oServer.evalNum(oServer.GetKey(Name, "height")) * Screen.TwipsPerPixelY
        temp = oServer.GetKey(Name, "FontFace")
        If temp <> "" Then
            m_oForm.lblText.Font = temp
        End If
        temp = oServer.GetKey(Name, "TextSize")
        If temp <> "" Then
            m_oForm.lblText.FontSize = CInt(temp)
        End If
        temp = oServer.GetKey(Name, "TextColor")
        If temp <> "" Then
            m_oForm.lblText.ForeColor = RGB(CByte("&H" & Left(temp, 2)), CByte("&H" & Mid(temp, 3, 2)), CByte("&H" & Right(temp, 2)))
        End If
        m_oForm.setup
        m_oForm.Show
        IBasePlugin_StartPlugin = m_oForm.hWnd
      Else
        oServer.Execute "!log this module only works under windows NT based systems"
        IBasePlugin_StartPlugin = 0
      End If
    End If

End Function
Public Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

    Select Case Name
    Case "!hide"
        If LCase(Arguments) = LCase(m_oForm.Tag) Then
            m_oForm.Hide
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_oForm.Tag) Then
            m_oForm.Show
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_oForm.Tag) Then
            m_oForm.Visible = Not m_oForm.Visible
        End If
    End Select
   
End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
